﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ResponsiveGridsTips.Controllers;
using Newtonsoft.Json;
using ResponsiveGridsTips.Models;
using Infragistics.Web.Mvc;

namespace ResponsiveGridsTips.Controllers
{
    public class HomeController : Controller
    {
        public static AdventureWorksModelContainer context = new AdventureWorksModelContainer();
        //
        // GET: /Home/

        public ActionResult Index()
        {
            ViewBag.Message = "This demo demonstrates the Ignite UI Grids' Responsive Web Design Mode feature.";

            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "This demo demonstrates the Ignite UI Grids' Responsive Web Design Mode feature.";
            return View();
        }

        public ActionResult MVCDemo()
        {
            ViewBag.Message = "Ignite UI Grid's Responsive Web Design Mode feature using the ASP.NET MVC helpers. Updating is enabled in Row Edit Template mode and adjustements are made to show editors for hidden columns and ensure good dialog size on mobile devices.";
            //because http://stackoverflow.com/a/10684658/1613589
            return View(context.People.Take(20).ToList().AsQueryable());
        }

        public ActionResult ResizableMVCDemo()
        {
            ViewBag.Message = "Ignite UI Grid's Responsive Web Design Mode feature using the ASP.NET MVC helpers. The Grid is placed inside a resizable dialog window modified to react to its width rather then the window.";
            return View(context.People.Take(20).ToList().AsQueryable());
        }

        public ActionResult Demo()
        {
            ViewBag.Message = "Ignite UI Grid's Responsive Web Design Mode feature. Updating is enabled in Row Edit Template mode and adjustements are made to show editors for hidden columns and ensure good dialog size on mobile devices.";
            return View(context.People.Take(20).ToList().AsQueryable());
        }

        public ActionResult ResizableDemo()
        {
            ViewBag.Message = "Ignite UI Grid's Responsive Web Design Mode feature. The Grid is placed inside a resizable dialog window modified to react to its width rather then the window.";
            return View(context.People.Take(20).ToList().AsQueryable());
        }

        public ActionResult HMVCDemo()
        {
            ViewBag.Message = "Ignite UI Hierarchical Grid's  Responsive Web Design Mode feature using the ASP.NET MVC helpers on both the parent and child layouts. Parent handling mode change event saves and restores expanded children between changes.";
            /* Lie and cheat to make the Departments with Employees and also allow it be normally seriazable */
            var departments = context.Departments.Select(d => new
            {
                DepartmentID = d.DepartmentID,
                Name = d.Name,
                GroupName = d.GroupName,
                ModifiedDate = d.ModifiedDate,
                Employees = d.EmployeeDepartmentHistories.Where(x => x.DepartmentID == d.DepartmentID).Where(x => x.EndDate == null).Select(x => x.Employee).Select(x => new
                {
                    BusinessEntityID = x.BusinessEntityID,
                    DepartmentID = d.DepartmentID,
                    NationalIDNumber = x.NationalIDNumber,
                    LoginID = x.LoginID,
                    OrganizationLevel = x.OrganizationLevel,
                    JobTitle = x.JobTitle,
                    BirthDate = x.BirthDate,
                    MaritalStatus = x.MaritalStatus,
                    Gender = x.Gender,
                    HireDate = x.HireDate,
                    SalariedFlag = x.SalariedFlag,
                    VacationHours = x.VacationHours,
                    SickLeaveHours = x.SickLeaveHours
                })
            }).ToList().AsQueryable();
            return View(departments);
        }

        public ActionResult HDemo()
        {
            ViewBag.Message = "Ignite UI Hierarchical Grid's Responsive Web Design Mode feature. on both the parent and child layouts. Parent handling mode change event saves and restores expanded children between changes.";
            return View();
        }

        public JsonResult Departments()
        {
            var departments = context.Departments.Select(d => new
            {
                DepartmentID = d.DepartmentID,
                Name = d.Name,
                GroupName = d.GroupName,
                ModifiedDate = d.ModifiedDate,
                Employees = d.EmployeeDepartmentHistories.Where(x => x.DepartmentID == d.DepartmentID).Where(x => x.EndDate == null).Select(x => x.Employee).Select(x => new
                {
                    BusinessEntityID = x.BusinessEntityID,
                    DepartmentID = d.DepartmentID,
                    NationalIDNumber = x.NationalIDNumber,
                    LoginID = x.LoginID,
                    OrganizationLevel = x.OrganizationLevel,
                    JobTitle = x.JobTitle,
                    BirthDate = x.BirthDate,
                    MaritalStatus = x.MaritalStatus,
                    Gender = x.Gender,
                    HireDate = x.HireDate,
                    SalariedFlag = x.SalariedFlag,
                    VacationHours = x.VacationHours,
                    SickLeaveHours = x.SickLeaveHours
                })
            }).ToList();
            return Json(departments, JsonRequestBehavior.AllowGet);
        }

        public ActionResult UpdatingSaveChanges()
        {
            var ds = context.People;
            GridModel grid = new GridModel();
            List<Transaction<Person>> transactions = grid.LoadTransactions<Person>(HttpContext.Request.Unvalidated["ig_transactions"]);
            //NOTE: You can also use JSON.NET in cases where the default serializators fail (which is torally not unheard of):
            //var transactions = JsonConvert.DeserializeObject<List<Transaction<Person>>>(Request.Form["ig_transactions"]);

            foreach (Transaction<Person> transaction in transactions.ToList())
            {
                int id = Int32.Parse(transaction.rowId);
                if (transaction.type == "row") //edit!
                {
                    var person = context.People.Where(x => x.BusinessEntityID == id).Single();
                    // Validate the data before saving!
                    context.Entry(person).CurrentValues.SetValues(transaction.row);
                }
                if (transaction.type == "delete") //delete!
                {
                    context.People.Remove(transaction.row);
                }
            }
            context.SaveChanges();
            Response.Write("{\"Success\": true}");
            return new JsonResult();
        }
    }
}
